/* ******************************************
 * aula05.c                                 *
 * creado por Dimas Martínez em 12/09/2012  *
 * curso de C -- aula 04                    *
 * IM - UFAL                                *
 *                                          *
 ********************************************/

#include <stdio.h>
#include <stdlib.h>

#define GRAY  1
#define RGB   3
#define R     0
#define G     1
#define B     2
#define GR    0


typedef struct// Imagem
{
   int linhas;
   int colunas;
   int tipo; // GRAY ou  RGB
   int ***dados;
}Imagem;
/*typedef struct Imagem Imagem;*/

void cria_imagem(Imagem* pI,  // Imagem que será criada
                 int linhas,  // numero de linhas 
                 int colunas, // numero de colunas
                 int tipo,    // GRAY o RGB
                 int*** dados // matriz(es) de cores
                )   
{
   pI->linhas  = linhas; // (*pI).linhas = linhas;
   pI->colunas = colunas;
   pI->tipo    = tipo;
   if (dados == NULL )
   {
      //allocar espaço para dados
      pI->dados = malloc(tipo*sizeof(int**));
      int i, j, k;
      for (i = 0; i < tipo; ++i)
      {
         pI->dados[i] = malloc(linhas*sizeof(int*));
         for (j = 0; j < linhas; ++j)
         {
            pI->dados[i][j] = malloc(colunas*sizeof(int));
         }
      }
   }
   else
      pI->dados = dados;
}

void limpa_imagem(Imagem I)
{
   if (I.dados != NULL )
   {
      int i, j, k;
      for (i = 0; i < I.tipo; ++i)
      {
         for (j = 0; j < I.linhas; ++j)
         {
            free(I.dados[i][j]);
         }
         free(I.dados[i]);
      }
      free(I.dados);
   }
}

void print_image(Imagem I);

int main(int argc, char** argv)
{
   Imagem imagem;
   cria_imagem(&imagem, 10, 15, RGB, NULL);

   print_image(imagem);

   limpa_imagem(imagem);

   exit(EXIT_SUCCESS);
}

void print_chanel(Imagem I, int ch)
{
   int i,j;
   for(i = 0; i < I.linhas; ++i)
   {
      printf("[");
      for(j = 0; j < I.colunas; ++j)
         printf("%3d ",I.dados[ch][i][j]);
      printf("]\n");
   }
   printf("\n");
}

void print_image(Imagem I)
{
   switch (I.tipo)
   {
      case GRAY:
         puts("Imagem Cinza");
         print_chanel(I,GR);
         break;
      case RGB:
         puts("Imagem RGB");
         puts("Canal Vermelho"); print_chanel(I,R);
         puts("Canal Verde");    print_chanel(I,G);
         puts("Canal Azul");     print_chanel(I,B);
         break;
      default:
         fprintf(stderr, "Erro: Tipo de imagem desconhecido.\n");
         exit(EXIT_FAILURE);
   }
}

